Bug 1256606 - all: Make all the xlator fops static to avoid incorrect symbol resolution
all: Make all the xlator fops static to avoid incorrect symbol resolution
Status: CLOSED CURRENTRELEASE
Product: GlusterFS
Classification: Community
Component: unclassified (Show other bugs)
3.7.3
All All
unspecified Severity medium
: ---
: ---
Assigned To: Soumya Koduri
: Triaged
Depends On: 1248669
Blocks: 1216951 1256485
  Show dependency treegraph
 
Reported: 2015-08-25 02:13 EDT by Soumya Koduri
Modified: 2016-02-05 06:29 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: 1248669
Environment:
Last Closed: 2016-02-05 06:29:23 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Soumya Koduri 2015-08-25 02:13:10 EDT
+++ This bug was initially created as a clone of Bug #1248669 +++

Description of problem:

As described in the bug1245636, we have encountered an issue where in the 'snapview-client' xlator lookup fop name 'svc_lookup' matches with one of the routines provided by libntirpc, used by NFS-Ganesha. Hence while using 'uss' feature over NFS-Ganesha, during dlopen() of the snapview-client xlator, as  'svc_lookup' is already loaded, 'xlator->fops->lookup' incorrectly refers to that symbol.

To avoid similar issues, it would be better and cleaner to mark all the xlator fops static. This bug is to track all the required changes.

--- Additional comment from Soumya Koduri on 2015-07-31 03:07:59 EDT ---



--- Additional comment from Anand Avati on 2015-07-31 05:02:54 EDT ---

REVIEW: http://review.gluster.org/11805 (snapshot: Make fops static for correct resolution of symbols) posted (#3) for review on master by soumya k (skoduri@redhat.com)

--- Additional comment from Anand Avati on 2015-08-04 08:54:22 EDT ---

REVIEW: http://review.gluster.org/11814 (build: export minimum symbols from xlators for correct resolution) posted (#21) for review on master by Kaleb KEITHLEY (kkeithle@redhat.com)

--- Additional comment from Anand Avati on 2015-08-24 13:23:13 EDT ---

COMMIT: http://review.gluster.org/11805 committed in master by Niels de Vos (ndevos@redhat.com) 
------
commit d5e03b7f02f68b3a9aaccf586e1f6ed901224ba7
Author: Soumya Koduri <skoduri@redhat.com>
Date:   Thu Jul 30 16:37:45 2015 +0530

    snapshot: Make fops static for correct resolution of symbols
    
    Few of the snapshot fops (like 'svc_lookup') may not get resolved
    while using dynamic loading as there could be other libraries(like libntirpc)
    with same routine names. Making them static to resolve the same.
    
    Change-Id: I6577bf3705864f5583425c94427b4e1025a59bcd
    BUG: 1248669
    Signed-off-by: Soumya Koduri <skoduri@redhat.com>
    Reviewed-on: http://review.gluster.org/11805
    Reviewed-by: Niels de Vos <ndevos@redhat.com>
    Tested-by: NetBSD Build System <jenkins@build.gluster.org>
    Reviewed-by: Rajesh Joseph <rjoseph@redhat.com>
    Tested-by: Gluster Build System <jenkins@build.gluster.com>

Note You need to log in before you can comment on or make changes to this bug.